#ifndef _ENGINE3D
#define _ENGINE3D

#include "functions.h"
#include "jump.h"

// do not modify the following values
#define HIDE 0
#define DISPLAY 1
#define DISTMIN 0
#define DISTMAX 1
#define pow2_15 32768
#define MAX 2147483647
#define profondeur 200
#define prop 2
#define PRECISION 1000
#define centrageX 64
#define centrageY 32
#define OBJEND 254
#define END 255
#define SOLID 1
#define TRANSPARENT 0

// modify the following values
#define barricade 0
#define cube 1
#define present 2
#define wall3x2F 3
#define rob1B 4
#define rob1H 5
#define rob2B 6
#define rob2H 7
#define parachute 8

#define COLLISIONDISTANCE 50
#define nbObjetsMaxInMap 500
#define nbObjetsMaxVisibleAtTheSameTime 150
#define nbObject 9

#define NBROBOTS 8

typedef enum {
	JUMP, BENDDOWN, NONE
} position;

typedef struct{
	int x, y, z, rotationXY, rotationYZ, rotationXZ;
	position action;
	char jumpCount;
} coordonneesCamera;

typedef struct{
	int x, y;
} coordonnees2D;

typedef struct{
	int x, y, z;
} coordonnees3D;

typedef struct{
	unsigned int object;
	unsigned char dim, texture;
} collisionDatas;

typedef struct{
	unsigned int object;
	unsigned int distance;
} aim;

collisionDatas view3D(int map[], unsigned int* objectList, coordonneesCamera* camera, coordonneesCamera* cameraMem, aim* currentAim, char hideInvisibleLines);
void loadObjects(unsigned int* objectList);

#endif