#include "functions.h"
#include "fxlib.h"
#include "time.h"

unsigned int random(int seed, int value) { // Function from Simon Lothar
    static unsigned int lastrandom = 0x12345678;
    if(seed) lastrandom = seed;
    lastrandom = (0x41C64E6D * lastrandom) + 0x3039;
    return ((lastrandom >> 16) % value);
}

int sq(int nb) {
	return nb*nb;
}

unsigned int puissance2(int value, unsigned char puissance) {
	unsigned char i;
	for(i = 1; i < puissance; i++)
		value *= 2;
	return puissance == 0 ? 1 : value;
}

int nbFigures(int number) {
	unsigned char i = 1;
	for(i = 1; i < 10; i++) {
		if(number % puissance10(i) == number)
			break;
	}
	return i;
}

void printVmini(int x, int y, int m) // Function from PierrotLL
{
	int i, lenght = 0;
	char str[12] = "0";
	
	if(m)
	{
		if(m < 0)
		{
			lenght ++;
			str[0] = '-';
			m = - m;
		}
		
		for(i=m; i; i/=10) lenght++ ;
		str[lenght] = 0;
		for( ; m; m/=10) str[--lenght] = m%10 + '0';
	}
	
	PrintMini(x,y, str, 0);
}

void displayVram() {
	ML_display_vram();
	ML_clear_vram();
}

static unsigned int puissance10(int puissance) {
	int i, value = 10;
	for(i = 1; i < puissance; i++)
		value *= 10;
	return value;
}