#include "key.h"
#include "fixed.h"
#include "fxlib.h"
#include "jump.h"

static void delay()
{
	unsigned char i;
	for(i=0 ; i<5 ; i++);
}

unsigned char key_down(unsigned char code) { // Function from PierrotLL
	int result=0;
	short*PORTB_CTRL=(void*)0xA4000102;
	short*PORTM_CTRL=(void*)0xA4000118;
	char*PORTB=(void*)0xA4000122;
	char*PORTM=(void*)0xA4000138;
	char*PORTA=(void*)0xA4000120;
	short smask;
	char cmask;
	unsigned char column, row;

	column = code>>4;
	row = code &0x0F;

	smask = 0x0003 << (( row %8)*2);
	cmask = ~( 1 << ( row %8) );
	if ( row <8)
	{
		// configure port B as input, except for the "row to check"-bit, which has to be an output.
		*PORTB_CTRL = 0xAAAA ^ smask;
		// configure port M as input; port M is inactive with row < 8
		*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
		delay();
		*PORTB = cmask;    // set the "row to check"-bit to 0 on port B
		*PORTM = (*PORTM & 0xF0 ) | 0x0F;    // port M is inactive with row < 8
	}
	else
	{
		*PORTB_CTRL = 0xAAAA;  // configure port B as input; port B is inactive with row >= 8
		// configure port M as input, except for the "row to check"-bit, which has to be an output.
		*PORTM_CTRL = ((*PORTM_CTRL & 0xFF00 ) | 0x00AA)  ^ smask;
		delay();
		*PORTB = 0xFF;    // port B is inactive with row >= 8 (all to 1)
		*PORTM = (*PORTM & 0xF0 ) | cmask;  // set the "row to check"-bit to 0
	};
	delay();
	result = (~(*PORTA))>>column&1;   // a pressed key in the row-to-check draws the corresponding bit to 0
	delay();
	*PORTB_CTRL = 0xAAAA;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
	delay();
	*PORTB_CTRL = 0x5555;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x0055;
	delay();
  return result;
}

unsigned int moveCamera(coordonneesCamera* camera, unsigned int time, weapon_position position, Infos *playerInfos) {
	if(time_getTicks() - time >= TIME) {
		int dX, dY;
		
		if(camera->action != JUMP && key_down(K_8)) {
				camera->action = JUMP;
				camera->jumpCount = 0;
		}
		if(key_down(K_2)) {
			if(camera->action == NONE) {
			camera->jumpCount = 0;
			camera->z -= BENDDOWNDISTANCE;
			camera->action = BENDDOWN;
			}
		}
		else {
			if(camera->action == BENDDOWN) {
				camera->z += BENDDOWNDISTANCE;
				camera->action = NONE;
			}
			if(key_down(K_RIGHT)) {
				camera->rotationXY += (position == NORMAL) ? NORMAL_HORIZONTAL_ROTATESPEED : BINOCULARS_HORIZONTAL_ROTATESPEED;
				if(camera->rotationXY >= 360) camera->rotationXY -= 360;
			}
			if(key_down(K_LEFT)) {
				camera->rotationXY -= (position == NORMAL) ? NORMAL_HORIZONTAL_ROTATESPEED : BINOCULARS_HORIZONTAL_ROTATESPEED;
				if(camera->rotationXY < 0) camera->rotationXY += 360;
			}
			
			if(key_down(K_DOWN) && camera->rotationYZ <= BOTTOM_LIMIT) camera->rotationYZ += (position == NORMAL) ? NORMAL_VERTICAL_ROTATESPEED : BINOCULARS_VERTICAL_ROTATESPEED;
			if(key_down(K_UP) && camera->rotationYZ >= TOP_LIMIT) camera->rotationYZ -= (position == NORMAL) ? NORMAL_VERTICAL_ROTATESPEED : BINOCULARS_VERTICAL_ROTATESPEED;

			dX = MOVESPEED * MOVEPRECISION * fcos(FIX(-camera->rotationXY + 90)) / pow2_15;
			dY = MOVESPEED * MOVEPRECISION * fsin(FIX(-camera->rotationXY + 90)) / pow2_15;
			
			if(IsKeyDown(KEY_CTRL_SHIFT)) { // bug beetween key_down() and overclock for SHIFT
				camera->x += dX;
				camera->y += dY;
				playerInfos->distance += MOVESPEED;
			}
			
			if(IsKeyDown(KEY_CTRL_ALPHA)) { // bug beetween key_down() and overclock for ALPHA
				camera->x -= dX;
				camera->y -= dY;
				playerInfos->distance += MOVESPEED;
			}
		}
		
		jump_and_bendDown(camera);
		gravity(camera);
		time = (key_down(K_MENU) || key_down(K_EXIT)) ? -1 : time_getTicks();
	}
	return time;
}