#include "maps.h"
#include "engine3D.h"
#include "key.h"
#include "functions.h"
#include "jump.h"

unsigned int mapWidth(unsigned int currentMap) {
	if(currentMap == 1) return 90; // map length
}

void loadMap(int *map, unsigned int currentMap, unsigned int MapWidth, coordonneesCamera* camera) {	
	char spamPoint;
	if(currentMap == 1) {
		const int mapTemporaire[] = { 
		
		/*
		// Robots
		*/
			// robot 1
			HIDE, rob1B, -2700, 1600, 0, XX, YY, ZZ,
			HIDE, rob1H, -2700 - 17, 1600 - 17, 120, XX, YY, ZZ,
			
			// robot 2
			HIDE, rob1B, -2700, 700, 0, XX, YY, ZZ,
			HIDE, rob1H, -2700 - 17, 700 - 17, 120, XX, YY, ZZ,
			
			// robot 3
			HIDE, rob1B, -1804, 1600, 0, XX, YY, ZZ,
			HIDE, rob1H, -1804 - 17, 1600 - 17, 120, XX, YY, ZZ,
			
			// robot 4
			HIDE, rob1B, -1804, 950, 0, XX, YY, ZZ,
			HIDE, rob1H, -1804 - 17, 950 - 17, 120, XX, YY, ZZ,
			
			// robot 5
			HIDE, rob1B, -2300, 100, 0, XX, YY, ZZ,
			HIDE, rob1H, -2300 - 17, 100 - 17, 120, XX, YY, ZZ,
			
			// robot 6
			HIDE, rob1B, -1300, 400, 0, XX, YY, ZZ,
			HIDE, rob1H, -1300 - 17, 400 - 17, 120, XX, YY, ZZ,
			
			// robot 7
			HIDE, rob1B, -900, 100, 0, XX, YY, ZZ,
			HIDE, rob1H, -900 - 17, 100 - 17, 120, XX, YY, ZZ,
			
			// robot 8
			HIDE, rob1B, -950, 1500, 0, XX, YY, ZZ,
			HIDE, rob1H, -950 - 17, 1500 - 17, 120, XX, YY, ZZ,
		
		/*
		// Presents
		*/		
			HIDE, present, -2600, 1200, 40, YY, XX, ZZ,
			HIDE, present, -1800, 200 - 20, 40, YY, XX, ZZ,
			HIDE, present, -800 - 20, 400, 40, XX, YY, ZZ,
			HIDE, present, -800 - 20, 1000, 40, XX, YY, ZZ,
			HIDE, present, -1400, 1400 - 20, 40, YY, XX, ZZ,
			
		/*
		// Objects
		*/	
			DISPLAY, cube, -2200, 1240, 0, YY, XX, ZZ,
			DISPLAY, cube, -2200, 1300, 0, YY, XX, ZZ,
			DISPLAY, cube, -2200, 1360, 0, YY, XX, ZZ,
			DISPLAY, cube, -2200, 1420, 0, YY, XX, ZZ,
			DISPLAY, cube, -2200, 1480, 0, YY, XX, ZZ,
			DISPLAY, barricade, -2200, 850, 0, YY, XX, ZZ,
			
		/*
		// Zone 1
		*/
			
			// walls
			DISPLAY, wall3x2F, -2800, 1800, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -2600, 1800, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -2400, 1800, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -2200, 1800, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -2000, 1800, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1800, 1800, 0, XX, YY, ZZ,
			
			DISPLAY, wall3x2F, -1600, 1600, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -1600, 1000, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -1600, 800, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -1600, 600, 0, YY, XX, ZZ,
			
			DISPLAY, wall3x2F, -1800, 600, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -2000, 600, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -2600, 600, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -2800, 600, 0, XX, YY, ZZ,
			
			DISPLAY, wall3x2F, -2800, 600, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -2800, 800, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -2800, 1000, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -2800, 1200, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -2800, 1400, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -2800, 1600, 0, YY, XX, ZZ,
			
			DISPLAY, wall3x2F, -2000, 400, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -2000, 400, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1800, 400, 0, XX, YY, ZZ,
			
			DISPLAY, wall3x2F, -2400, 400, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -2400, 200, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -2400, 0, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -2400, 0, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -2200, 0, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -2000, 0, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1800, 0, 0, XX, YY, ZZ,
			
		/*
		// Zone 2
		*/
		
			// walls
			DISPLAY, wall3x2F, -1600, 1600, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1400, 1600, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1200, 1600, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1000, 1600, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -800, 1600, 0, XX, YY, ZZ,
			
			DISPLAY, wall3x2F, -600, 1400, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -600, 1200, 0, YY, XX, ZZ,
			
			DISPLAY, wall3x2F, -600, 1000, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -600, 800, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -600, 600, 0, YY, XX, ZZ,
			
			DISPLAY, wall3x2F, -600, 600, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -400, 400, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -400, 200, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -400, 0, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -400, -200, 0, YY, XX, ZZ,
			
			DISPLAY, wall3x2F, -600, -200, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -800, -200, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1000, -200, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1200, -200, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1400, -200, 0, XX, YY, ZZ,
			
			DISPLAY, wall3x2F, -1400, -200, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -1600, 0, 0, XX, YY, ZZ,
			
			DISPLAY, wall3x2F, -1600, 1200, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1400, 1200, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1200, 1200, 0, XX, YY, ZZ,
			
			DISPLAY, wall3x2F, -1000, 1000, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -1000, 800, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -1000, 600, 0, YY, XX, ZZ,
			
			DISPLAY, wall3x2F, -1200, 600, 0, XX, YY, ZZ,
			DISPLAY, wall3x2F, -1400, 600, 0, XX, YY, ZZ,
			
			DISPLAY, wall3x2F, -1400, 400, 0, YY, XX, ZZ,
			DISPLAY, wall3x2F, -1600, 400, 0, XX, YY, ZZ,
			
			MAPEND
		};
		
		spamPoint = random(0, 4);
		switch(spamPoint) {
			case 0:
				camera->x = -900;
				camera->y = 40;
				camera->rotationXY = 0;
				break;
			case 1:
				camera->x = -1000;
				camera->y = 1400;
				camera->rotationXY = -90;
				break;
			case 2:
				camera->x = -2500;
				camera->y = 1400;
				camera->rotationXY = 180;
				break;
			case 3:
				camera->x = -2200;
				camera->y = 200;	
				camera->rotationXY = 90;
				break;
		}
		camera->z = 150;
		camera->rotationYZ = 0;
		camera->rotationXZ = 0;
		camera->action = NONE;
		camera->jumpCount = 0;
		
		memcpy(map, mapTemporaire, sizeof(int)*(MapWidth * 8 + 1));
	}	

	camera->x *= MOVEPRECISION;
	camera->y *= MOVEPRECISION;
}