#include "menus.h"
#include "MonochromeLib.h"
#include "tileset.h"
#include "key.h"
#include "contrast.h"

Choice menu(unsigned char contrastValue) {
	Choice choice = NOTHING;
	Tileset *mainMenu;
	mainMenu = tileset_load(MENU);
	ML_bmp_or(mainMenu->tile[0], 0, 0, mainMenu->width, mainMenu->height);
	displayVram();
	moove_contrast(contrastValue, INCREASE);
	tileset_free(mainMenu);
	while(choice == NOTHING) {
		if(key_down(K_EXE) || key_down(K_SHIFT) || key_down(K_ALPHA))
			choice = PLAY;	
		if(key_down(K_EXIT) || key_down(K_MENU) || key_down(K_AC))
			choice = QUIT;	
	}
	moove_contrast(contrastValue, DECREASE);
	return choice;
}

void game_over(Infos playerInfos, unsigned char contrastValue) {
	int i, j, k = 0;
	Tileset *gameOver;
	
	set_contrast(contrastValue - MOOVECONTRASTTIME);
	
	gameOver = tileset_load(GAMEOVER);
	ML_bmp_or(gameOver->tile[0], 0, 4, gameOver->width, gameOver->height);
	
	PrintMini(3, 26, "Bullets shooted:", 0);
	printVmini(70, 26, playerInfos.nbShoots);
	
	PrintMini(3, 35, "Robots killed:", 0);
	printVmini(61, 35, playerInfos.nbKilled);
	
	PrintMini(3, 44, "Distance walked:", 0);
	playerInfos.distance /= 100;
	i = playerInfos.distance / 1000;
	if(i > 0) {
		printVmini(72, 44, i);
		j = nbFigures(i);
		PrintMini(74 + 4 * j, 44, "Km", 0);
		k = 15 + 4 * j;
	}
	else
		PrintMini(74 + k + 4 * nbFigures(playerInfos.distance % 1000), 44, "m", 0);
	if(playerInfos.distance % 1000 != 0 || i == 0)
		printVmini(72 + k, 44, playerInfos.distance % 1000);
	
	PrintMini(3, 53, "You survived", 0);
	playerInfos.gameTime = (time_getTicks() - playerInfos.gameTime) / 128;
	k = 0;
	i = playerInfos.gameTime / 3600;
	if(i > 0) {
		printVmini(54, 53, i);
		j = nbFigures(i);
		PrintMini(56 + 4 * j, 53, "h", 0);
		k = 8 + 4 * j;
	}
	i = (playerInfos.gameTime % 3600) / 60;
	if(i > 0) {
		printVmini(54 + k, 53, i);
		j = nbFigures(i);
		PrintMini(56 + k + 4 * j, 53, "min", 0);
		k += 17 + 4 * j;
	}
	i = (playerInfos.gameTime % 3600) % 60;
	if(i != 0 || k == 0) {
		printVmini(54 + k, 53, i);
		PrintMini(55 + k + 4 * nbFigures(i), 53, "'", 0);
	}
	
	displayVram();
	moove_contrast(contrastValue, INCREASE);
	tileset_free(gameOver);
	
	Sleep(500);
	while(!key_down(K_EXE) && !key_down(K_SHIFT)) {}
}