#include "player.h"
#include "MonochromeLib.h"
#include "functions.h"
#include "time.h"

Infos infos_init(Infos playerInfos) {
	playerInfos.manche = 1;
	playerInfos.munitions = 10;
	playerInfos.nbShoots = 0;
	playerInfos.life = 0;
	playerInfos.gameTime = time_getTicks();
	playerInfos.currentMessage.message = NOMESSAGE;
	return playerInfos;
}

void displayInfos(Tileset* bannier, Tileset* mancheGun, Infos* playerInfos) {
	unsigned int i;
	
	ML_bmp_or(bannier->tile[0], 0, 0, bannier->width, bannier->height);
	ML_bmp_and(bannier->tile[1], 0, 0, bannier->width, bannier->height);
	
	for(i = 0; i < playerInfos->manche && i < 3; i++)
		ML_bmp_or(mancheGun->tile[0],11 * i + 1, 9, mancheGun->width, mancheGun->height);
		
	switch(playerInfos->currentMessage.message) { 
		case HEADSHOT:
			PrintMini(53, 2, "Headshot !", 0);
		break;
		case _GUN:
			PrintMini(64, 2, "+ Gun", 0);
		break;
		case _SNIPER:
			PrintMini(58, 2, "+ Sniper", 0);
		break;
		case _10BULLETS:
			PrintMini(47, 2, "+10 munitions", 0);
		break;
		case _30BULLETS:
			PrintMini(47, 2, "+30 munitions", 0);
		break;
		case _50BULLETS:
			PrintMini(47, 2, "+50 munitions", 0);
		break;
	}
	
	if(time_getTicks() - playerInfos->currentMessage.time > 500)
		playerInfos->currentMessage.message = NOMESSAGE;
	
	printVmini(117 - 4 * nbFigures(playerInfos->munitions), 2, playerInfos->munitions);
}