#include "robots.h"
#include "functions.h"
#include "contrast.h"
#include "time.h"

void spawnRobots(int* map, Infos* player, robotsInfos* robots) {
	unsigned int nb;
	if(random(0, 300) == 1 && robots->nbspawned[0] < 2 + 2 * player->manche) {
		nb = random(0, NBROBOTS);
		if(robots->list[nb] != ALIVE) {
			robots->list[nb] = ALIVE;
			robots->nbspawned[0]++;
			map[nb * 16] = DISPLAY;
			map[nb * 16 + 8] = DISPLAY;
		}
	}
}

Infos shot(Infos playerInfos, int* map, robotsInfos* robots, weapon_datas* currentWeapon, aim currentAim) {
	if(currentWeapon->shot != NOTSHOT && currentAim.object <= (NBROBOTS - 1) * 16 + 8) {
		if(currentAim.distance > 0 && (currentWeapon->shot == SHOT || (currentAim.distance < 62500 && random(0, 2) == 1))) {
			robots->list[currentAim.object / 16] = DEAD;
			robots->nbspawned[0]--;
			playerInfos.nbKilled++;
			if(currentAim.object % 16 == 0) {
				if(map[currentAim.object + 8] == HIDE) {
					robots->nbspawned[0]++;
					playerInfos.nbKilled--;
				}
				else
					map[currentAim.object + 8] = HIDE;
			}
			else if(currentWeapon->shot == SHOT) {
				playerInfos.currentMessage.message = HEADSHOT;
				playerInfos.currentMessage.time = time_getTicks();
			}
				
			map[currentAim.object] = HIDE;
		}
		if((playerInfos.nbKilled > 10 && playerInfos.manche == 1) || (playerInfos.nbKilled > 30 && playerInfos.manche == 2))
			playerInfos.manche++;
	}
	currentWeapon->shot = NOTSHOT;
	return playerInfos;
}

Infos loseLife(Infos playerInfos, robotsInfos robots, coordonneesCamera player, unsigned char contrastValue) {
	char touched = 0;
	
	// robot 1
	if(random(0, 150 * (4 - playerInfos.manche)) == 1 && robots.list[0] == ALIVE && player.x < -160000 && player.y > 100000 && !(player.action == BENDDOWN && player.x > -220000 && player.x < -180000 && player.y < 154000 && player.y > 120000))
		touched++;
	// robot 2
	if(random(0, 150 * (4 - playerInfos.manche)) == 1 && robots.list[1] == ALIVE && player.x < -160000 && player.y > 60000 && player.y < 140000 && !(player.action == BENDDOWN && player.x > -220000 && player.x < -180000 && player.y > 85000 && player.y < 115000))
		touched++;	
	// robot 3
	if(random(0, 150 * (4 - playerInfos.manche)) == 1 && robots.list[2] == ALIVE && player.x < -160000 && player.y > 100000 && !(player.action == BENDDOWN && player.x < -220000 && player.x > -260000 && player.y < 154000 && player.y > 120000))
		touched++;
	// robot 4
	if(random(0, 150 * (4 - playerInfos.manche)) == 1 && robots.list[3] == ALIVE && player.x < -160000 && player.y > 40000 && !(player.action == BENDDOWN && ((player.x < -220000 && player.x > -260000 && player.y < 154000 && player.y > 120000) || (player.x < -220000 && player.x > -260000 && player.y > 85000 && player.y < 105000))))
		touched++;
	// robot 5
	if(random(0, 150 * (4 - playerInfos.manche)) == 1 && robots.list[4] == ALIVE && ((player.x < -200000 && player.x > -220000 && player.y < 70000 && player.y > 0) || (player.x < -120000 && player.x > -220000 && player.y < 40000 && player.y > 0)))
		touched++;
	// robot 6
	if(random(0, 150 * (4 - playerInfos.manche)) == 1 && robots.list[5] == ALIVE && player.x < -40000 && player.x > -140000 && player.y > -20000 && player.y < 60000)
		touched++;
	// robot 7
	if(random(0, 150 * (4 - playerInfos.manche)) == 1 && robots.list[6] == ALIVE && player.x < -40000 && player.x > -180000 && player.y > -20000 && player.y < 100000)
		touched++;
	// robot 8
	if(random(0, 150 * (4 - playerInfos.manche)) == 1 && robots.list[7] == ALIVE && ((player.x > -180000 && player.x < -60000 && player.y < 160000 && player.y > 120000) || (player.x < -60000 && player.x > -100000 && player.y > 40000 && player.y < 160000)))
		touched++;
	
	if(touched > 0) {
		playerInfos.life++;
		set_contrast(contrastValue - 5 * playerInfos.life);
		playerInfos.timeToIncreaseLife = time_getTicks();
	}
	
	if(time_getTicks() - playerInfos.timeToIncreaseLife > INCREASELIFETIME * playerInfos.manche && playerInfos.life > 0) {
		playerInfos.life--;
		set_contrast(contrastValue - 5 * playerInfos.life);
	}
	
	return playerInfos;
}