#include <fxlib.h>
#include "weapons.h"
#include "MonochromeLib.h"
#include "time.h"
#include "tileset.h"
#include "key.h"

weapon_datas weapons_init(weapon_datas currentWeapon, weapon_name *weaponList) {
	unsigned char i;
	currentWeapon.timeSinceLastShot = 0;
	currentWeapon.weaponChangementTime = 0;
	currentWeapon.shot = NOTSHOT;
	currentWeapon.name = DEFAULT_WEAPON;
	weaponList[0] = currentWeapon.name;
	currentWeapon.position = NORMAL;
	for(i = 1; i < NBWEAPON; i++)
		weaponList[i] = NO_WEAPON;
	return currentWeapon;
}

weapon_datas setWeapons(weapon_datas currentWeapon, weapon_name *weaponList, coordonneesCamera* camera, Infos* playerInfos) {	
	if(IsKeyDown(KEY_CTRL_F6) && time_getTicks() - currentWeapon.weaponChangementTime > WEAPON_CHANGEMENT_TIME) {
		char i, step = 0;
		weapon_name NewWeapon = NO_WEAPON;
		for(i = 0; i < NBWEAPON; i++) {
			if(weaponList[i] != NO_WEAPON && (weaponList[i] != currentWeapon.name || step == 1)) {
				NewWeapon = weaponList[i];
				if(step == 1) break;
			}
			if(weaponList[i] == currentWeapon.name) {
				step = 1;
				NewWeapon = NO_WEAPON;
			}
			if(i == NBWEAPON - 1 && (NewWeapon == NO_WEAPON || step == 0))
				i = -1;
		}
		if(NewWeapon != NO_WEAPON) {
			currentWeapon.name = NewWeapon;
			currentWeapon.position = NORMAL;
			currentWeapon.timeSinceLastShot = 0;
			currentWeapon.timeSinceLastPositionChangement = 0;
			currentWeapon.weaponChangementTime = time_getTicks(); 
		}
	}
	
	if(currentWeapon.name == SNIPER && key_down(K_OPTN) && time_getTicks() - currentWeapon.timeSinceLastPositionChangement > POSITION_CHANGEMENT_TIME) {
		currentWeapon.position = (currentWeapon.position == NORMAL) ? BINOCULARS : NORMAL;
		currentWeapon.timeSinceLastPositionChangement = time_getTicks();
	}
	
	if(currentWeapon.name == KNIFE && IsKeyDown(KEY_CTRL_F1) && time_getTicks() - currentWeapon.timeSinceLastShot > KNIFE_BEETWEEN_SHOTS_TIME) {
		currentWeapon.timeSinceLastShot = time_getTicks();
		currentWeapon.shot = CUT;
	}
	
	if(currentWeapon.name == GUN && IsKeyDown(KEY_CTRL_F1) && time_getTicks() - currentWeapon.timeSinceLastShot > GUN_BEETWEEN_SHOTS_TIME && playerInfos->munitions > 0) {
		currentWeapon.timeSinceLastShot = time_getTicks();
		currentWeapon.shot = SHOT;
		playerInfos->munitions--;
		playerInfos->nbShoots++;
	}
	else if(currentWeapon.name == SNIPER) {
		if(IsKeyDown(KEY_CTRL_F1) && time_getTicks() - currentWeapon.timeSinceLastShot > SNIPER_BEETWEEN_SHOTS_TIME && playerInfos->munitions > 0) {
			currentWeapon.timeSinceLastShot = time_getTicks();
			currentWeapon.shot = SHOT;
			currentWeapon.count = 0;
			playerInfos->munitions--;
			playerInfos->nbShoots++;
		}
		if(time_getTicks() - currentWeapon.timeSinceLastShot < 50 && currentWeapon.position == BINOCULARS && currentWeapon.count < 2 * BINOCULAR_SHOOT_STEPS) {
			if(time_getTicks() - currentWeapon.timeSinceLastShot >= SNIPER_SHOOT_TIME_BEETWEEN_STEPS * currentWeapon.count) {
				camera->rotationYZ -= (currentWeapon.count < BINOCULAR_SHOOT_STEPS) ? BINOCULAR_SHOOT_MOVEMENT_BEETWEEN_STEPS : - BINOCULAR_SHOOT_MOVEMENT_BEETWEEN_STEPS;
				currentWeapon.count++;
			}
		}
	}
	
	return currentWeapon;
}

void displayWeapons(weapon_datas currentWeapon) {
	Tileset *SpriteWeapon;
	char place;
	
	if(currentWeapon.name == KNIFE) {
		if(time_getTicks() - currentWeapon.timeSinceLastShot < KNIFE_TIME_2) {
			SpriteWeapon = tileset_load(S_KNIFE2);
			if(time_getTicks() - currentWeapon.timeSinceLastShot < KNIFE_TIME_1)
				place = 45;
			else
				place = 70;
		}
		else {
			SpriteWeapon = tileset_load(S_KNIFE1);
			place = 80;
		}
	}
	else if(currentWeapon.name == GUN) {
		place = 80;
		if(time_getTicks() - currentWeapon.timeSinceLastShot < GUN_SHOT_TIME)
			SpriteWeapon = tileset_load(S_GUN2);
		else
			SpriteWeapon = tileset_load(S_GUN1);
	}
	else if(currentWeapon.name == SNIPER) {
		if(currentWeapon.position == BINOCULARS) {
			place = 0;
			SpriteWeapon = tileset_load(S_SNIPER_TIR);
		}
		else {
			place = 79;
			if(time_getTicks() - currentWeapon.timeSinceLastShot < SNIPER_SHOT_TIME)
				SpriteWeapon = tileset_load(S_SNIPER2);
			else
				SpriteWeapon = tileset_load(S_SNIPER1);
		}
	}
	
	ML_bmp_or(SpriteWeapon->tile[0], place, 64 - SpriteWeapon->height, SpriteWeapon->width, SpriteWeapon->height);
	if(currentWeapon.position != BINOCULARS) ML_bmp_and(SpriteWeapon->tile[1], place, 64 - SpriteWeapon->height, SpriteWeapon->width, SpriteWeapon->height);
	tileset_free(SpriteWeapon);
}