#ifndef _WEAPONS
#define _WEAPONS

#include "engine3D.h"
#include "player.h"

#define DEFAULT_WEAPON KNIFE

#define KNIFE_TIME_1 35
#define KNIFE_TIME_2 70
#define KNIFE_BEETWEEN_SHOTS_TIME 68
#define GUN_SHOT_TIME 25
#define GUN_BEETWEEN_SHOTS_TIME 110
#define SNIPER_SHOT_TIME 25
#define SNIPER_BEETWEEN_SHOTS_TIME 150
#define BINOCULAR_SHOOT_STEPS 1
#define SNIPER_SHOOT_TIME_BEETWEEN_STEPS 5
#define BINOCULAR_SHOOT_MOVEMENT_BEETWEEN_STEPS 3

#define POSITION_CHANGEMENT_TIME 80
#define WEAPON_CHANGEMENT_TIME 60

#define NBWEAPON 3

typedef enum {
	NO_WEAPON,
	KNIFE, GUN, SNIPER
} weapon_name;

typedef enum {
	NORMAL, BINOCULARS
} weapon_position;

typedef enum {
	SHOT, NOTSHOT, CUT
} Shot;

typedef struct {
	weapon_name name;
	weapon_position position;
	unsigned int timeSinceLastShot, weaponChangementTime, timeSinceLastPositionChangement;
	unsigned char count;
	Shot shot;
} weapon_datas;

weapon_datas weapons_init(weapon_datas currentWeapon, weapon_name *weaponList);
weapon_datas setWeapons(weapon_datas currentWeapon, weapon_name *weaponList, coordonneesCamera* camera, Infos* playerInfos);
void displayWeapons(weapon_datas currentWeapon);

#endif